<template>
  <v-tabs
    v-model="model"
    :items="items"
    :grow="grow"
    :color="activeColor"
    :show-arrows="showArrows"
    :align-tabs="alignTabs"
    @update:model-value="update"
  >
    <template #tab="{ item }">
      <v-tab
        :prepend-icon="item?.icon"
        :text="item?.text"
        :value="item?.value"
        :class="item?.class"
      ></v-tab>
    </template>
  </v-tabs>
</template>

<script setup>
import { ref, watch, onMounted } from 'vue';
import { TabAlignTypes } from '../../constants/types';

const props = defineProps({
  modelValue: {
    type: String,
    default: undefined
  },
  activeColor: {
    type: String,
    default: "primary",
  },
  showArrows: {
    type: Boolean,
    default: false,
  },
  items: {
    type: Array,
    default: () => [],
    validator: (value) =>  Array.isArray(value)
  },
  grow: {
    type: Boolean,
    default: false,
  },
  alignTabs: {
    type: String,
    default: TabAlignTypes.START,
    validator: (value) => Object.values(TabAlignTypes).find((element) => element === value)
  }
});

const emit = defineEmits(['update:modelValue'])

const model = ref(props.modelValue);

onMounted(() => {
  model.value = props?.modelValue
});

const update = (newValue) => {
  model.value = newValue;
  emit('update:modelValue', newValue)
}

watch(props, (newValue, oldValue) => {
  if (newValue?.modelValue) {
    model.value = newValue?.modelValue
  }
})
</script>